--*** Fire effect by Keith Degrse. Ported to Euphoria/Asm by Mic.           ***--
--*** Horribly slow in plain Euphoria, but with the help of machine code it- ***--
--*** now runs at 170 fps on my machine (without a vertical-retrace wait).   ***--
--*** This version does wait for a vertical retrace though, just to avoid-   ***--
--*** any flickering. This takes it down to about 70 fps but that should be- ***--
--*** fast enough.						             ***--
--*** Note that the fire will look slightly different every time you run-    ***--
--*** the program. This is because of random-pixel thingy.		     ***--
--*** The "scanline"-effect was achived by doing a couple of small changes-  ***--
--*** in the original code. To remove the scanlines, change the two lines-   ***--
--*** in the assembly code that says "add eax,320" to "add eax,640". You'll- ***--
--*** also HAVE to change the line at the end of code that says "add dl,1"-  ***--
--*** to "add dl,2". It's as easy as that.                                   ***--
--*** Try commenting the two lines that says "shl eax,8", "add eax,ebx" for- ***--
--*** a cool effect.							     ***--

                        
include machine.e
include m19lib.e
--*** fire_code.e contains the drawing code ***--
include fire_code.e

without warning
without type_check

integer x, y
sequence pal
atom vscreen
atom time1,time2,frames

--*** Main code ***--
--*** allocate a 320*202 pixels virtual screen.                                ***--
--*** the 2 extra rows is where the random pixels are written, it'd look ugly- ***--
--*** to have them on-screen.                                                  ***--
vscreen=allocate(64640)
pal=repeat({63,63,63},256)
pal[1]={0,0,0}
--*** This is where the palette is determined.			               ***--
--*** It'll go from black to red to orange to yellow to white.                 ***--
for i=1 to 32 do
 pal[i+1]={(i*2)-1,0,0}
 pal[i+32+1]={63,(i*2)-1,0}
 pal[i+64+1]={63,63,(i*2)-1}
end for
set_vga()
set_pal(pal)
mem_cls(vscreen,0)


frames=0
--*** get starting-time ***--
time1=time()
--*** Main loop ***--
while get_key()=-1 do
 x=0
 while (x<320) do
  --*** the top of the fire will be at y=2 ***--
  y=2
  --*** set reading-address ***--
  poke4(asm_fireAddr,(vscreen+(y*320)+x-2))
  --*** set writing-address ***--
  poke4(asm_fireAddr2,(vscreen+((y-2)*320)+x))
  --*** call the routine ***--
  call(fireCode)
  --*** randomize the flames ***--
  poke(vscreen+(200*320)+x,(rand(2)*128)+25)
  poke(vscreen+(201*320)+x,(rand(2)*128)+45)
  x=x+2
 end while
 wait_vrt()
 asm_copy_screen(vscreen,#A0000)
 frames=frames+1
end while
--***End of main loop ***--

--*** get ending-time ***--
time2=time()


restore_graphics()

--*** free some memory ***--
free_asm_code()
free(vscreen)
free(fireCode)
free(asm_fireAddr)
free(asm_fireAddr2)

--*** print fps ***--
printf(1,"%d flaming frames per second.\n",floor(frames/(time2-time1)))

--*** End of Main code ***--
 